// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.validator;

import javax.faces.context.FacesContext;
import javax.el.ValueExpression;
import javax.faces.validator.Validator;
import javax.faces.application.Application;
import javax.servlet.jsp.JspException;


public class ValidateUrlTag
    extends org.apache.myfaces.commons.validator.ValidatorBaseTag
{
    private static final long serialVersionUID = 6041422002721046221L; 

    public ValidateUrlTag()
    {    
    }    
 
    private ValueExpression _schemes;
    
    public void setSchemes(ValueExpression schemes)
    {
        _schemes = schemes;
    }
 
    private ValueExpression _allow2Slashes;
    
    public void setAllow2Slashes(ValueExpression allow2Slashes)
    {
        _allow2Slashes = allow2Slashes;
    }
 
    private ValueExpression _allowAllSchemas;
    
    public void setAllowAllSchemas(ValueExpression allowAllSchemas)
    {
        _allowAllSchemas = allowAllSchemas;
    }

    protected Validator createValidator() throws JspException {
        String validatorId = "org.apache.myfaces.commons.validator.Url";
        Application appl = FacesContext.getCurrentInstance().getApplication();
        Validator validator = (Validator)appl.createValidator(validatorId);
        _setProperties(validator);
        return validator;
    }
    
    protected void _setProperties(Validator val) throws JspException {
        super._setProperties(val);
        FacesContext facesContext = FacesContext.getCurrentInstance();

        org.apache.myfaces.commons.validator.UrlValidator validator = (org.apache.myfaces.commons.validator.UrlValidator) val;
        if (_schemes != null)
        {
            if (!_schemes.isLiteralText())
            {
                validator.setValueExpression("schemes", _schemes);
            }
            else
            {
                Object _schemesValue = _schemes.getValue(facesContext.getELContext());
                if (_schemesValue != null)
                {
                    validator.setSchemes(
                        (java.lang.String)  _schemesValue.toString());                
                }
            }
        }
        if (_allow2Slashes != null)
        {
            if (!_allow2Slashes.isLiteralText())
            {
                validator.setValueExpression("allow2Slashes", _allow2Slashes);
            }
            else
            {
                Object _allow2SlashesValue = _allow2Slashes.getValue(facesContext.getELContext());
                if (_allow2SlashesValue != null){
                    if (_allow2SlashesValue instanceof Boolean){
                        validator.setAllow2Slashes(
                            ((Boolean)_allow2SlashesValue).booleanValue());                        
                    }
                    else
                    {
                        validator.setAllow2Slashes(
                            Boolean.valueOf(_allow2SlashesValue.toString()).booleanValue());
                    }                    
                }
            }
        }
        if (_allowAllSchemas != null)
        {
            if (!_allowAllSchemas.isLiteralText())
            {
                validator.setValueExpression("allowAllSchemas", _allowAllSchemas);
            }
            else
            {
                Object _allowAllSchemasValue = _allowAllSchemas.getValue(facesContext.getELContext());
                if (_allowAllSchemasValue != null){
                    if (_allowAllSchemasValue instanceof Boolean){
                        validator.setAllowAllSchemas(
                            ((Boolean)_allowAllSchemasValue).booleanValue());                        
                    }
                    else
                    {
                        validator.setAllowAllSchemas(
                            Boolean.valueOf(_allowAllSchemasValue.toString()).booleanValue());
                    }                    
                }
            }
        }
    }

    public void release()
    {
        super.release();
        _schemes = null;
        _allow2Slashes = null;
        _allowAllSchemas = null;
    }
}
